'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

class ExceptionBase extends Error {
    constructor(typeName, message, line = 0, column = 0) {
        const lineAndColumnText = line > 0 && column > 0 ? ` at line ${line}, column ${column}` : '';
        const str = `${typeName}${lineAndColumnText}: ${message}`;
        super(str);
        this.str = str;
        this.line = line;
        this.column = column;
    }
    toString() {
        return this.str;
    }
}

class ArgumentException extends ExceptionBase {
    constructor(message, argumentName, line = 0, column = 0) {
        super('ArgumentException', message, line, column);
        this.argumentName = argumentName;
        this.argumentName = argumentName;
    }
}

class EvaluationException extends ExceptionBase {
    constructor(message, line = 0, column = 0) {
        super('EvaluationException', message, line, column);
    }
}

class GrammarException extends ExceptionBase {
    constructor(message, line = 0, column = 0) {
        super('GrammarException', message, line, column);
    }
}

var n,t,e,r,i;!function(n){n[n.UndefinedSymbol=0]="UndefinedSymbol",n[n.Lambda=1]="Lambda",n[n.Dot=2]="Dot",n[n.terminalBegin=3]="terminalBegin",n[n.terminalEnd=4]="terminalEnd",n[n.terminalAssign=5]="terminalAssign",n[n.terminalSemicolon=6]="terminalSemicolon",n[n.terminalRead=7]="terminalRead",n[n.terminalWrite=8]="terminalWrite",n[n.terminalLeftBracket=9]="terminalLeftBracket",n[n.terminalRightBracket=10]="terminalRightBracket",n[n.terminalLeftSquareBracket=11]="terminalLeftSquareBracket",n[n.terminalRightSquareBracket=12]="terminalRightSquareBracket",n[n.terminalOrBar=13]="terminalOrBar",n[n.terminalComma=14]="terminalComma",n[n.terminalID=15]="terminalID",n[n.terminalVariable=16]="terminalVariable",n[n.terminalIntegerLiteral=17]="terminalIntegerLiteral",n[n.terminalFloatLiteral=18]="terminalFloatLiteral",n[n.terminalStringLiteral=19]="terminalStringLiteral",n[n.terminalPlus=20]="terminalPlus",n[n.terminalMinus=21]="terminalMinus",n[n.terminalCond=22]="terminalCond",n[n.terminalLet=23]="terminalLet",n[n.terminalLetStar=24]="terminalLetStar",n[n.terminalDefine=25]="terminalDefine",n[n.terminalIf=26]="terminalIf",n[n.terminalWhile=27]="terminalWhile",n[n.terminalSet=28]="terminalSet",n[n.terminalMultiply=29]="terminalMultiply",n[n.terminalDivide=30]="terminalDivide",n[n.terminalEquals=31]="terminalEquals",n[n.terminalLessThan=32]="terminalLessThan",n[n.terminalGreaterThan=33]="terminalGreaterThan",n[n.terminalPrint=34]="terminalPrint",n[n.terminalCons=35]="terminalCons",n[n.terminalCar=36]="terminalCar",n[n.terminalCdr=37]="terminalCdr",n[n.terminalNumberPred=38]="terminalNumberPred",n[n.terminalSymbolPred=39]="terminalSymbolPred",n[n.terminalListPred=40]="terminalListPred",n[n.terminalNullPred=41]="terminalNullPred",n[n.terminalStringPred=42]="terminalStringPred",n[n.terminalApostrophe=43]="terminalApostrophe",n[n.terminalDot=44]="terminalDot",n[n.terminalList=45]="terminalList",n[n.terminalRplaca=46]="terminalRplaca",n[n.terminalRplacd=47]="terminalRplacd",n[n.terminalDefineMacro=48]="terminalDefineMacro",n[n.terminalQuoteKeyword=49]="terminalQuoteKeyword",n[n.terminalRandom=50]="terminalRandom",n[n.terminalToString=51]="terminalToString",n[n.terminalListToString=52]="terminalListToString",n[n.terminalStringToList=53]="terminalStringToList",n[n.terminalStringToSymbol=54]="terminalStringToSymbol",n[n.terminalSin=55]="terminalSin",n[n.terminalCos=56]="terminalCos",n[n.terminalTan=57]="terminalTan",n[n.terminalPow=58]="terminalPow",n[n.terminalExp=59]="terminalExp",n[n.terminalLn=60]="terminalLn",n[n.terminalFloor=61]="terminalFloor",n[n.terminalAtan2=62]="terminalAtan2",n[n.terminalThrow=63]="terminalThrow",n[n.terminalStringLessThan=64]="terminalStringLessThan",n[n.terminalPrimOpPred=65]="terminalPrimOpPred",n[n.terminalClosurePred=66]="terminalClosurePred",n[n.terminalLambdaKeyword=67]="terminalLambdaKeyword",n[n.terminalLetRec=68]="terminalLetRec",n[n.terminalCallCC=69]="terminalCallCC",n[n.terminalNameBeginningWithCapital=70]="terminalNameBeginningWithCapital",n[n.terminalNameNotBeginningWithCapital=71]="terminalNameNotBeginningWithCapital",n[n.terminalFrom=72]="terminalFrom",n[n.terminalInferPred=73]="terminalInferPred",n[n.terminalNotSymbol=74]="terminalNotSymbol",n[n.terminalIs=75]="terminalIs",n[n.terminalLessOrEqual=76]="terminalLessOrEqual",n[n.terminalGreaterOrEqual=77]="terminalGreaterOrEqual",n[n.terminalNotEqual=78]="terminalNotEqual",n[n.terminalArithmeticEqual=79]="terminalArithmeticEqual",n[n.terminalArithmeticNotEqual=80]="terminalArithmeticNotEqual",n[n.terminalUnifiable=81]="terminalUnifiable",n[n.terminalNotUnifiable=82]="terminalNotUnifiable",n[n.terminalIfThen=83]="terminalIfThen",n[n.terminalColon=84]="terminalColon",n[n.terminalDCGArrow=85]="terminalDCGArrow",n[n.terminalUniv=86]="terminalUniv",n[n.terminalCaret=87]="terminalCaret",n[n.terminalFn=88]="terminalFn",n[n.terminalThickArrow=89]="terminalThickArrow",n[n.terminalIn=90]="terminalIn",n[n.terminalTrue=91]="terminalTrue",n[n.terminalFalse=92]="terminalFalse",n[n.terminalComb=93]="terminalComb",n[n.terminalInc=94]="terminalInc",n[n.terminalDec=95]="terminalDec",n[n.terminalAnd=96]="terminalAnd",n[n.terminalOr=97]="terminalOr",n[n.terminalIsZero=98]="terminalIsZero",n[n.terminalNil=99]="terminalNil",n[n.terminalOctothorpe=100]="terminalOctothorpe",n[n.terminalDollar=101]="terminalDollar",n[n.terminalClass=102]="terminalClass",n[n.terminalObjectPred=103]="terminalObjectPred",n[n.terminalStrlen=104]="terminalStrlen",n[n.terminalSubstr=105]="terminalSubstr",n[n.terminalTypename=106]="terminalTypename",n[n.terminalStrcat=107]="terminalStrcat",n[n.terminalNewArray=108]="terminalNewArray",n[n.terminalArrayLength=109]="terminalArrayLength",n[n.terminalArrayGet=110]="terminalArrayGet",n[n.terminalArraySet=111]="terminalArraySet",n[n.terminalArrayPred=112]="terminalArrayPred",n[n.terminalCharPred=113]="terminalCharPred",n[n.terminalStringIndex=114]="terminalStringIndex",n[n.terminalVectorConst=115]="terminalVectorConst",n[n.terminalMax=116]="terminalMax",n[n.terminalPlusSlash=117]="terminalPlusSlash",n[n.terminalMinusSlash=118]="terminalMinusSlash",n[n.terminalMultiplySlash=119]="terminalMultiplySlash",n[n.terminalDivideSlash=120]="terminalDivideSlash",n[n.terminalMaxSlash=121]="terminalMaxSlash",n[n.terminalOrSlash=122]="terminalOrSlash",n[n.terminalAndSlash=123]="terminalAndSlash",n[n.terminalCompress=124]="terminalCompress",n[n.terminalShape=125]="terminalShape",n[n.terminalRavel=126]="terminalRavel",n[n.terminalRestruct=127]="terminalRestruct",n[n.terminalCat=128]="terminalCat",n[n.terminalIndx=129]="terminalIndx",n[n.terminalTrans=130]="terminalTrans",n[n.terminalSquareBrackets=131]="terminalSquareBrackets",n[n.terminalDoubleSubscripting=132]="terminalDoubleSubscripting",n[n.terminalCluster=133]="terminalCluster",n[n.terminalRep=134]="terminalRep",n[n.terminalExport=135]="terminalExport",n[n.terminalThen=136]="terminalThen",n[n.terminalElse=137]="terminalElse",n[n.terminalCall=138]="terminalCall",n[n.terminalTypeBoolean=139]="terminalTypeBoolean",n[n.terminalTypeByte=140]="terminalTypeByte",n[n.terminalTypeClosure=141]="terminalTypeClosure",n[n.terminalTypeInteger=142]="terminalTypeInteger",n[n.terminalTypeFloatingPoint=143]="terminalTypeFloatingPoint",n[n.terminalTypeList=144]="terminalTypeList",n[n.terminalTypeMap=145]="terminalTypeMap",n[n.terminalTypeString=146]="terminalTypeString",n[n.terminalModulus=147]="terminalModulus",n[n.terminalMapGet=148]="terminalMapGet",n[n.terminalMapSet=149]="terminalMapSet",n[n.terminalAsync=150]="terminalAsync",n[n.terminalPlusEqual=151]="terminalPlusEqual",n[n.terminalMinusEqual=152]="terminalMinusEqual",n[n.terminalMultiplyEqual=153]="terminalMultiplyEqual",n[n.terminalDivideEqual=154]="terminalDivideEqual",n[n.terminalModulusEqual=155]="terminalModulusEqual",n[n.terminalLeftCurlyBrace=156]="terminalLeftCurlyBrace",n[n.terminalRightCurlyBrace=157]="terminalRightCurlyBrace",n[n.terminalDo=158]="terminalDo",n[n.terminalForEach=159]="terminalForEach",n[n.terminalDeclare=160]="terminalDeclare",n[n.terminalBooleanPred=161]="terminalBooleanPred",n[n.terminalMapPred=162]="terminalMapPred",n[n.terminalPairPred=163]="terminalPairPred",n[n.terminalLogicalNot=164]="terminalLogicalNot",n[n.terminalBitwiseAnd=165]="terminalBitwiseAnd",n[n.terminalBitwiseOr=166]="terminalBitwiseOr",n[n.terminalBitwiseXor=167]="terminalBitwiseXor",n[n.terminalBitwiseNot=168]="terminalBitwiseNot",n[n.terminalBitwiseShiftLeft=169]="terminalBitwiseShiftLeft",n[n.terminalBitwiseShiftRight=170]="terminalBitwiseShiftRight",n[n.terminalBitwiseAndEqual=171]="terminalBitwiseAndEqual",n[n.terminalBitwiseOrEqual=172]="terminalBitwiseOrEqual",n[n.terminalBitwiseXorEqual=173]="terminalBitwiseXorEqual",n[n.terminalBitwiseShiftLeftEqual=174]="terminalBitwiseShiftLeftEqual",n[n.terminalBitwiseShiftRightEqual=175]="terminalBitwiseShiftRightEqual",n[n.terminalIncrement=176]="terminalIncrement",n[n.terminalDecrement=177]="terminalDecrement",n[n.terminalQuestionMark=178]="terminalQuestionMark",n[n.terminalColonColon=179]="terminalColonColon",n[n.terminalEOF=180]="terminalEOF",n[n.nonterminalStart=181]="nonterminalStart",n[n.nonterminalProgram=182]="nonterminalProgram",n[n.nonterminalStatementList=183]="nonterminalStatementList",n[n.nonterminalStatementTail=184]="nonterminalStatementTail",n[n.nonterminalStatement=185]="nonterminalStatement",n[n.nonterminalIDList=186]="nonterminalIDList",n[n.nonterminalIDTail=187]="nonterminalIDTail",n[n.nonterminalExprList=188]="nonterminalExprList",n[n.nonterminalExprTail=189]="nonterminalExprTail",n[n.nonterminalExpression=190]="nonterminalExpression",n[n.nonterminalTerm=191]="nonterminalTerm",n[n.nonterminalPrimaryTail=192]="nonterminalPrimaryTail",n[n.nonterminalPrimary=193]="nonterminalPrimary",n[n.nonterminalAddOp=194]="nonterminalAddOp",n[n.nonterminalBracketedEntity=195]="nonterminalBracketedEntity",n[n.nonterminalInput=196]="nonterminalInput",n[n.nonterminalFunDef=197]="nonterminalFunDef",n[n.nonterminalFunction=198]="nonterminalFunction",n[n.nonterminalArgList=199]="nonterminalArgList",n[n.nonterminalVariableList=200]="nonterminalVariableList",n[n.nonterminalVariable=201]="nonterminalVariable",n[n.nonterminalValue=202]="nonterminalValue",n[n.nonterminalBracketedExpression=203]="nonterminalBracketedExpression",n[n.nonterminalExpressionList=204]="nonterminalExpressionList",n[n.nonterminalOptr=205]="nonterminalOptr",n[n.nonterminalValueOp=206]="nonterminalValueOp",n[n.nonterminalQuotedConst=207]="nonterminalQuotedConst",n[n.nonterminalSExpression=208]="nonterminalSExpression",n[n.nonterminalSExpressionList=209]="nonterminalSExpressionList",n[n.nonterminalSymbol=210]="nonterminalSymbol",n[n.nonterminalMacroDef=211]="nonterminalMacroDef",n[n.nonterminalExprPairList=212]="nonterminalExprPairList",n[n.nonterminalLetKeyword=213]="nonterminalLetKeyword",n[n.nonterminalVarExprList=214]="nonterminalVarExprList",n[n.nonterminalBracketedInput=215]="nonterminalBracketedInput",n[n.nonterminalUnbracketedInput=216]="nonterminalUnbracketedInput",n[n.nonterminalSExpressionListTail=217]="nonterminalSExpressionListTail",n[n.nonterminalClause=218]="nonterminalClause",n[n.nonterminalQuery=219]="nonterminalQuery",n[n.nonterminalGoal=220]="nonterminalGoal",n[n.nonterminalClauseTail=221]="nonterminalClauseTail",n[n.nonterminalGoalList=222]="nonterminalGoalList",n[n.nonterminalGoalListTail=223]="nonterminalGoalListTail",n[n.nonterminalList=224]="nonterminalList",n[n.nonterminalListContents=225]="nonterminalListContents",n[n.nonterminalListContentsTail=226]="nonterminalListContentsTail",n[n.nonterminalFunctorExpression=227]="nonterminalFunctorExpression",n[n.nonterminalTailOfGoalOrFunctorExpression=228]="nonterminalTailOfGoalOrFunctorExpression",n[n.nonterminalExpressionListTail=229]="nonterminalExpressionListTail",n[n.nonterminalGoalTail1=230]="nonterminalGoalTail1",n[n.nonterminalVariableOrNumericLiteral=231]="nonterminalVariableOrNumericLiteral",n[n.nonterminalLambdaExpression=232]="nonterminalLambdaExpression",n[n.nonterminalLetStatement=233]="nonterminalLetStatement",n[n.nonterminalFunctionCall=234]="nonterminalFunctionCall",n[n.nonterminalAfterVariable=235]="nonterminalAfterVariable",n[n.nonterminalClassDef=236]="nonterminalClassDef",n[n.nonterminalClass=237]="nonterminalClass",n[n.nonterminalInstVars=238]="nonterminalInstVars",n[n.nonterminalMethodDef=239]="nonterminalMethodDef",n[n.nonterminalMethodDefList=240]="nonterminalMethodDefList",n[n.nonterminalLiteralList=241]="nonterminalLiteralList",n[n.nonterminalVectorConst=242]="nonterminalVectorConst",n[n.nonterminalIntegerLiteralList=243]="nonterminalIntegerLiteralList",n[n.nonterminalClusterDef=244]="nonterminalClusterDef",n[n.nonterminalRep=245]="nonterminalRep",n[n.nonterminalFunDefList=246]="nonterminalFunDefList",n[n.nonterminalOnePartName=247]="nonterminalOnePartName",n[n.nonterminalOnePartNameTail=248]="nonterminalOnePartNameTail",n[n.nonterminalExportList=249]="nonterminalExportList",n[n.nonterminalOnePartNameList=250]="nonterminalOnePartNameList",n[n.nonterminalArithmeticExpression=251]="nonterminalArithmeticExpression",n[n.nonterminalArithmeticExpression0=252]="nonterminalArithmeticExpression0",n[n.nonterminalArithmeticExpression1=253]="nonterminalArithmeticExpression1",n[n.nonterminalArithmeticExpression2=254]="nonterminalArithmeticExpression2",n[n.nonterminalArithmeticExpression3=255]="nonterminalArithmeticExpression3",n[n.nonterminalArithmeticExpression4=256]="nonterminalArithmeticExpression4",n[n.nonterminalArithmeticExpression5=257]="nonterminalArithmeticExpression5",n[n.nonterminalArithmeticExpression6=258]="nonterminalArithmeticExpression6",n[n.nonterminalArithmeticExpression7=259]="nonterminalArithmeticExpression7",n[n.nonterminalArithmeticExpression8=260]="nonterminalArithmeticExpression8",n[n.nonterminalArithmeticExpression9=261]="nonterminalArithmeticExpression9",n[n.nonterminalArithmeticExpression10=262]="nonterminalArithmeticExpression10",n[n.nonterminalArithmeticExpression11=263]="nonterminalArithmeticExpression11",n[n.nonterminalArithmeticExpression12=264]="nonterminalArithmeticExpression12",n[n.nonterminalArithmeticExpression13=265]="nonterminalArithmeticExpression13",n[n.nonterminalArithmeticExpression14=266]="nonterminalArithmeticExpression14",n[n.nonterminalArithmeticExpression15=267]="nonterminalArithmeticExpression15",n[n.nonterminalArithmeticOperator=268]="nonterminalArithmeticOperator",n[n.nonterminalArithmeticOperator1=269]="nonterminalArithmeticOperator1",n[n.nonterminalArithmeticOperator2=270]="nonterminalArithmeticOperator2",n[n.nonterminalArithmeticOperator3=271]="nonterminalArithmeticOperator3",n[n.nonterminalArithmeticOperator4=272]="nonterminalArithmeticOperator4",n[n.nonterminalArithmeticOperator5=273]="nonterminalArithmeticOperator5",n[n.nonterminalArithmeticOperator6=274]="nonterminalArithmeticOperator6",n[n.nonterminalArithmeticOperator7=275]="nonterminalArithmeticOperator7",n[n.nonterminalArithmeticOperator8=276]="nonterminalArithmeticOperator8",n[n.nonterminalArithmeticOperator9=277]="nonterminalArithmeticOperator9",n[n.nonterminalArithmeticOperator10=278]="nonterminalArithmeticOperator10",n[n.nonterminalArithmeticOperator11=279]="nonterminalArithmeticOperator11",n[n.nonterminalArithmeticOperator12=280]="nonterminalArithmeticOperator12",n[n.nonterminalArithmeticOperator13=281]="nonterminalArithmeticOperator13",n[n.nonterminalArithmeticOperator14=282]="nonterminalArithmeticOperator14",n[n.nonterminalArithmeticOperator15=283]="nonterminalArithmeticOperator15",n[n.nonterminalArithmeticComparisonOperator=284]="nonterminalArithmeticComparisonOperator",n[n.nonterminalActualParameterList=285]="nonterminalActualParameterList",n[n.nonterminalFormalParameterList=286]="nonterminalFormalParameterList",n[n.nonterminalCommaSeparatedVariableList=287]="nonterminalCommaSeparatedVariableList",n[n.nonterminalCommaSeparatedExpressionList=288]="nonterminalCommaSeparatedExpressionList",n[n.nonterminalTypeName=289]="nonterminalTypeName",n[n.nonterminalTypeExpression=290]="nonterminalTypeExpression",n[n.nonterminalTypeParameterized=291]="nonterminalTypeParameterized",n[n.nonterminalOptionalElseBlock=292]="nonterminalOptionalElseBlock",n[n.nonterminalNonEmptyExpressionList=293]="nonterminalNonEmptyExpressionList",n[n.nonterminalLValue=294]="nonterminalLValue",n[n.nonterminalAssignmentOperator=295]="nonterminalAssignmentOperator",n[n.nonterminalBlock=296]="nonterminalBlock",n[n.nonterminalDeclarationPartOfBlock=297]="nonterminalDeclarationPartOfBlock",n[n.nonterminalDeclaration=298]="nonterminalDeclaration",n[n.nonterminalDeclarationList=299]="nonterminalDeclarationList",n[n.nonterminalValueList=300]="nonterminalValueList",n[n.nonterminalValueListTail=301]="nonterminalValueListTail";}(n||(n={})),function(n){n[n.MinimalLanguage=0]="MinimalLanguage",n[n.Micro=1]="Micro",n[n.Chapter1=2]="Chapter1",n[n.LISP=3]="LISP",n[n.APL=4]="APL",n[n.Scheme=5]="Scheme",n[n.SASL=6]="SASL",n[n.CLU=7]="CLU",n[n.Smalltalk=8]="Smalltalk",n[n.Prolog=9]="Prolog",n[n.Prolog2=10]="Prolog2",n[n.Inference=11]="Inference",n[n.JSON=12]="JSON",n[n.EcstaSKI=13]="EcstaSKI",n[n.Adso=14]="Adso",n[n.LambdaCalculus=15]="LambdaCalculus",n[n.LambdaCalculusWithAugmentedSyntax=16]="LambdaCalculusWithAugmentedSyntax",n[n.LambdaCalculusIntegerExtension=17]="LambdaCalculusIntegerExtension",n[n.C=18]="C",n[n.N1=19]="N1",n[n.Arithmetic=20]="Arithmetic",n[n.Fxx=21]="Fxx",n[n.Protos=22]="Protos";}(t||(t={})),function(n){n[n.MidnightHack=1]="MidnightHack",n[n.FiniteStateMachine=2]="FiniteStateMachine";}(e||(e={})),function(n){n[n.tokenNone=1]="tokenNone",n[n.tokenIntLit=2]="tokenIntLit",n[n.tokenFltLit=3]="tokenFltLit",n[n.tokenStrLit=4]="tokenStrLit",n[n.tokenStrLit2=5]="tokenStrLit2",n[n.tokenIdent=6]="tokenIdent",n[n.tokenBoolIdent=7]="tokenBoolIdent",n[n.tokenSkolemIdent=8]="tokenSkolemIdent",n[n.tokenVariable=9]="tokenVariable",n[n.tokenPlus=10]="tokenPlus",n[n.tokenMinus=11]="tokenMinus",n[n.tokenMult=12]="tokenMult",n[n.tokenDiv=13]="tokenDiv",n[n.tokenEqual=14]="tokenEqual",n[n.tokenNotEqual=15]="tokenNotEqual",n[n.tokenLess=16]="tokenLess",n[n.tokenLessEqual=17]="tokenLessEqual",n[n.tokenGreater=18]="tokenGreater",n[n.tokenGreaterEqual=19]="tokenGreaterEqual",n[n.tokenSemicolon=20]="tokenSemicolon",n[n.tokenComma=21]="tokenComma",n[n.token2OrBar=22]="token2OrBar",n[n.token2Ampersand=23]="token2Ampersand",n[n.tokenLeftBracket=24]="tokenLeftBracket",n[n.tokenRightBracket=25]="tokenRightBracket",n[n.tokenAssign=26]="tokenAssign",n[n.tokenArrow=27]="tokenArrow",n[n.tokenThickArrow=28]="tokenThickArrow",n[n.tokenExclamation=29]="tokenExclamation",n[n.tokenApostrophe=30]="tokenApostrophe",n[n.tokenOctothorpe=31]="tokenOctothorpe",n[n.tokenDollar=32]="tokenDollar",n[n.tokenDot=33]="tokenDot",n[n.tokenLeftSquareBracket=34]="tokenLeftSquareBracket",n[n.tokenRightSquareBracket=35]="tokenRightSquareBracket",n[n.tokenOrBar=36]="tokenOrBar",n[n.tokenAmpersand=37]="tokenAmpersand",n[n.tokenColon=38]="tokenColon",n[n.tokenLeftCurlyBrace=39]="tokenLeftCurlyBrace",n[n.tokenRightCurlyBrace=40]="tokenRightCurlyBrace",n[n.tokenQuoteKeyword=41]="tokenQuoteKeyword",n[n.tokenQuestionMinus=42]="tokenQuestionMinus",n[n.tokenColonMinus=43]="tokenColonMinus",n[n.tokenEqualLessThan=44]="tokenEqualLessThan",n[n.tokenBackslashPlus=45]="tokenBackslashPlus",n[n.tokenBackslashEqual=46]="tokenBackslashEqual",n[n.tokenEqualEqual=47]="tokenEqualEqual",n[n.tokenBackslashEqualEqual=48]="tokenBackslashEqualEqual",n[n.tokenEqualColonEqual=49]="tokenEqualColonEqual",n[n.tokenEqualBackslashEqual=50]="tokenEqualBackslashEqual",n[n.tokenMinusMinusGreaterThan=51]="tokenMinusMinusGreaterThan",n[n.tokenEqualDotDot=52]="tokenEqualDotDot",n[n.tokenCaret=53]="tokenCaret",n[n.tokenTilde=54]="tokenTilde",n[n.tokenLowercaseGreekLetterLambda=55]="tokenLowercaseGreekLetterLambda",n[n.tokenPercent=56]="tokenPercent",n[n.tokenPlusEqual=57]="tokenPlusEqual",n[n.tokenMinusEqual=58]="tokenMinusEqual",n[n.tokenMultEqual=59]="tokenMultEqual",n[n.tokenDivEqual=60]="tokenDivEqual",n[n.tokenPercentEqual=61]="tokenPercentEqual",n[n.tokenForAll=62]="tokenForAll",n[n.tokenThereExists=63]="tokenThereExists",n[n.tokenThereDoesNotExist=64]="tokenThereDoesNotExist",n[n.tokenEmptySet=65]="tokenEmptySet",n[n.tokenIsAnElementOf=66]="tokenIsAnElementOf",n[n.tokenIntersection=67]="tokenIntersection",n[n.tokenUnion=68]="tokenUnion",n[n.tokenIsASubsetOf=69]="tokenIsASubsetOf",n[n.tokenIsAProperSubsetOf=70]="tokenIsAProperSubsetOf",n[n.tokenBitwiseShiftLeft=71]="tokenBitwiseShiftLeft",n[n.tokenBitwiseShiftRight=72]="tokenBitwiseShiftRight",n[n.tokenBitwiseAndEqual=73]="tokenBitwiseAndEqual",n[n.tokenBitwiseOrEqual=74]="tokenBitwiseOrEqual",n[n.tokenBitwiseXorEqual=75]="tokenBitwiseXorEqual",n[n.tokenBitwiseShiftLeftEqual=76]="tokenBitwiseShiftLeftEqual",n[n.tokenBitwiseShiftRightEqual=77]="tokenBitwiseShiftRightEqual",n[n.tokenPlusPlus=78]="tokenPlusPlus",n[n.tokenMinusMinus=79]="tokenMinusMinus",n[n.tokenQuestionMark=80]="tokenQuestionMark",n[n.tokenColonColon=81]="tokenColonColon",n[n.tokenEOF=82]="tokenEOF",n[n.stateStart=83]="stateStart",n[n.stateError=84]="stateError",n[n.stateStrLitOpen=85]="stateStrLitOpen",n[n.stateStrLit2Open=86]="stateStrLit2Open",n[n.stateIntLitDot=87]="stateIntLitDot",n[n.stateQuestion=88]="stateQuestion",n[n.stateAmpersand=89]="stateAmpersand",n[n.stateAt=90]="stateAt",n[n.stateDollar=91]="stateDollar",n[n.stateBackslash=92]="stateBackslash",n[n.stateEqualColon=93]="stateEqualColon",n[n.stateEqualBackslash=94]="stateEqualBackslash",n[n.stateMinusMinus=95]="stateMinusMinus",n[n.stateEqualDot=96]="stateEqualDot";}(r||(r={})),function(n){n[n.LL1=0]="LL1",n[n.LR0=1]="LR0",n[n.LR1=2]="LR1",n[n.SLR1=3]="SLR1",n[n.LALR1=4]="LALR1";}(i||(i={}));

class Name {
    constructor(value, line = 0, column = 0) {
        this.value = value;
        this.line = line;
        this.column = column;
        if (!value) {
            throw new ArgumentException('Name constructor: A Name cannot have a null or empty value', 'value');
        }
    }
    toString() {
        return this.value;
    }
}

const typenameProduction = 'Production';
function isProduction(obj) {
    const otherProduction = obj;
    const lhs = otherProduction.lhs;
    const rhs = otherProduction.rhs;
    return (typeof otherProduction !== 'undefined' &&
        otherProduction.typename === typenameProduction &&
        typeof lhs !== 'undefined' &&
        typeof lhs === 'number' &&
        typeof rhs !== 'undefined' &&
        rhs instanceof Array &&
        rhs.every((element) => typeof element === 'number' || typeof element === 'string'));
}
class Production {
    constructor(lhs, rhs, num) {
        this.lhs = lhs;
        this.rhs = rhs;
        this.num = num;
        this.typename = typenameProduction;
    }
    toString() {
        const lhsAsString = n[this.lhs];
        const rhsAsString = this.rhs
            .map((s) => {
            if (typeof s === 'string') {
                return s;
            }
            else {
                return n[s];
            }
        })
            .join(' ');
        return `${this.num}: ${lhsAsString} -> ${rhsAsString}`;
    }
    equals(other) {
        return (isProduction(other) &&
            other.lhs === this.lhs &&
            other.rhs.length === this.rhs.length &&
            other.rhs.every((obj, i) => obj === this.rhs[i]));
    }
    getRHSWithNoSemanticActions() {
        return this.rhs
            .filter((s) => typeof s !== 'string')
            .map((s) => s);
    }
    stripOutSemanticActions() {
        return new Production(this.lhs, this.getRHSWithNoSemanticActions(), this.num);
    }
    containsSymbol(symbol) {
        return (this.lhs === symbol ||
            typeof this.rhs.find((s) => s === symbol) !== 'undefined');
    }
}
function createProduction(lhs, rhs, num = 0) {
    return new Production(lhs, rhs, num);
}

function isTerminalSymbol(gs) {
    return gs > n.Dot && gs <= n.terminalEOF;
}
function isNonTerminalSymbol(gs) {
    return gs > n.terminalEOF;
}
class GrammarBase {
    constructor(startSymbol) {
        this.startSymbol = startSymbol;
        this.terminals = [];
        this.nonTerminals = [];
        this.productions = [];
    }
    get defaultLexicalAnalyzer() {
        return e.MidnightHack;
    }
    get defaultParser() {
        return i.LL1;
    }
    get selectorsOfCompatibleParsers() {
        return [this.defaultParser];
    }
    tokenToSymbol(token) {
        const tokenValueAsString = token.tokenValue;
        switch (token.tokenType) {
            case r.tokenEOF:
                return n.terminalEOF;
            case r.tokenIntLit:
                return n.terminalIntegerLiteral;
            case r.tokenFltLit:
                return n.terminalFloatLiteral;
            case r.tokenStrLit:
                return n.terminalStringLiteral;
            case r.tokenPlus:
                return n.terminalPlus;
            case r.tokenMinus:
                return n.terminalMinus;
            case r.tokenMult:
                return n.terminalMultiply;
            case r.tokenDiv:
                return n.terminalDivide;
            case r.tokenEqual:
                return n.terminalEquals;
            case r.tokenLess:
                return n.terminalLessThan;
            case r.tokenGreater:
                return n.terminalGreaterThan;
            case r.tokenLeftBracket:
                return n.terminalLeftBracket;
            case r.tokenRightBracket:
                return n.terminalRightBracket;
            case r.tokenApostrophe:
                return n.terminalApostrophe;
            case r.tokenComma:
                return n.terminalComma;
            case r.tokenDollar:
                return n.terminalDollar;
            case r.tokenOctothorpe:
                return n.terminalOctothorpe;
            case r.tokenIdent:
                switch (tokenValueAsString) {
                    case 'define':
                        return n.terminalDefine;
                    case 'if':
                        return n.terminalIf;
                    case 'while':
                        return n.terminalWhile;
                    case 'set':
                        return n.terminalSet;
                    case 'begin':
                        return n.terminalBegin;
                    case 'print':
                        return n.terminalPrint;
                    case 'cond':
                        return n.terminalCond;
                    case 'let':
                        return n.terminalLet;
                    case 'let*':
                        return n.terminalLetStar;
                    case 'random':
                        return n.terminalRandom;
                    case 'pow':
                        return n.terminalPow;
                    case 'exp':
                        return n.terminalExp;
                    case 'ln':
                        return n.terminalLn;
                    case 'sin':
                        return n.terminalSin;
                    case 'cos':
                        return n.terminalCos;
                    case 'tan':
                        return n.terminalTan;
                    default:
                        return n.terminalID;
                }
            default:
                throw new GrammarException(`GrammarBase.tokenToSymbol() : No grammar symbol matches token ${token.tokenType} ${r[token.tokenType]} (value '${token.tokenValue}')`, token.line, token.column);
        }
    }
    pushTokenOntoSemanticStack(semanticStack, tokenAsSymbol, token) {
        switch (tokenAsSymbol) {
            case n.terminalID:
            case n.terminalPrint:
            case n.terminalPlus:
            case n.terminalMinus:
            case n.terminalMultiply:
            case n.terminalDivide:
            case n.terminalEquals:
            case n.terminalLessThan:
            case n.terminalGreaterThan:
            case n.terminalLet:
            case n.terminalLetStar:
            case n.terminalRandom:
            case n.terminalPow:
            case n.terminalExp:
            case n.terminalLn:
            case n.terminalSin:
            case n.terminalCos:
            case n.terminalTan:
            case n.terminalThrow:
                semanticStack.push(new Name(token.tokenValue, token.line, token.column));
                break;
            case n.terminalLeftBracket:
            case n.terminalRightBracket:
            case n.terminalBegin:
            case n.terminalCond:
            case n.terminalDefine:
            case n.terminalIf:
            case n.terminalSet:
            case n.terminalWhile:
            case n.terminalEOF:
                break;
            default:
                throw new GrammarException(`pushTokenOntoSemanticStack() : Unexpected tokenAsSymbol ${n[tokenAsSymbol]} (${tokenAsSymbol})`, token.line, token.column);
        }
    }
    findStartingProduction() {
        const results = [];
        for (const p of this.productions) {
            if (p.lhs === this.startSymbol) {
                const p2 = p.stripOutSemanticActions();
                if (p2.rhs.length > 0) {
                    const lastObject = p2.rhs[p2.rhs.length - 1];
                    if (lastObject === n.terminalEOF) {
                        results.push(p2);
                    }
                }
            }
        }
        if (results.length !== 1) {
            throw new GrammarException(`GrammarBase.FindStartingProduction() : Expected one starting production; found ${results.length}.`);
        }
        return results[0];
    }
    addProduction(lhs, rhs, n = NaN) {
        this.productions.push(createProduction(lhs, rhs, Number.isNaN(n) ? this.productions.length + 1 : n));
        for (const sym of [lhs, ...rhs]) {
            if (typeof sym !== 'number') {
                continue;
            }
            if (isTerminalSymbol(sym) && this.terminals.indexOf(sym) < 0) {
                this.terminals.push(sym);
            }
            if (isNonTerminalSymbol(sym) && this.nonTerminals.indexOf(sym) < 0) {
                this.nonTerminals.push(sym);
            }
        }
    }
}

exports.ArgumentException = ArgumentException;
exports.EvaluationException = EvaluationException;
exports.ExceptionBase = ExceptionBase;
exports.GrammarBase = GrammarBase;
exports.GrammarException = GrammarException;
exports.Name = Name;
exports.createProduction = createProduction;
exports.isNonTerminalSymbol = isNonTerminalSymbol;
exports.isProduction = isProduction;
exports.isTerminalSymbol = isTerminalSymbol;
